"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var CypherTypes = _interopRequireWildcard(require("../../lang/CypherTypes"));
var CompletionTypes = _interopRequireWildcard(require("../CompletionTypes"));
var _TreeUtils = require("../../util/TreeUtils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/*
 * Copyright (c) "Neo4j"
 * Neo4j Sweden AB [http://neo4j.com]
 *
 * This file is part of Neo4j.
 *
 * Neo4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

const childToParentTypeMapping = {
  [CypherTypes.VARIABLE_CONTEXT]: [{
    type: CompletionTypes.VARIABLE
  }],
  [CypherTypes.PARAMETER_NAME_CONTEXT]: [{
    type: CompletionTypes.PARAMETER
  }],
  [CypherTypes.PROPERTY_KEY_NAME_CONTEXT]: [{
    type: CompletionTypes.PROPERTY_KEY
  }],
  [CypherTypes.FUNCTION_NAME_CONTEXT]: [{
    type: CompletionTypes.FUNCTION_NAME
  }],
  [CypherTypes.PROCEDURE_NAME_CONTEXT]: [{
    type: CompletionTypes.PROCEDURE_NAME
  }],
  [CypherTypes.NODE_LABEL_CONTEXT]: [{
    type: CompletionTypes.LABEL
  }],
  [CypherTypes.RELATIONSHIP_TYPE_CONTEXT]: [{
    type: CompletionTypes.RELATIONSHIP_TYPE
  }],
  [CypherTypes.RELATIONSHIP_TYPE_OPTIONAL_COLON_CONTEXT]: [{
    type: CompletionTypes.RELATIONSHIP_TYPE
  }],
  [CypherTypes.CONSOLE_COMMAND_NAME_CONTEXT]: [{
    type: CompletionTypes.CONSOLE_COMMAND_NAME
  }],
  [CypherTypes.NODE_LABELS_CONTEXT]: [{
    type: CompletionTypes.LABEL
  }],
  [CypherTypes.RELATIONSHIP_TYPES_CONTEXT]: [{
    type: CompletionTypes.RELATIONSHIP_TYPE
  }]
};

// Check that element is inside specific parent context
var _default = element => {
  const parent = _TreeUtils.TreeUtils.findAnyParent(element, Object.keys(childToParentTypeMapping));
  return parent != null ? childToParentTypeMapping[parent.constructor.name] : [];
};
exports.default = _default;